import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.Timer;

public class Bounce extends JPanel implements ActionListener {
	private final int DELAY = 20;

	private Animator animator = new Animator();

	private Timer timer = new Timer(DELAY, this);

	public Bounce() {
		animator.add(new RectangleShape(0, 0, 2, 3));
		animator.add(new RectangleShape(10, 10, 5, 7));
		timer.start();
	}

	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		int width = getSize().width - 1;
		int height = getSize().height - 1;
		animator.clock(width, height, new GraphicsPainter(g));
	}

	public static void main(String[] args) {
		JFrame frame = new JFrame("Bounce");
		frame.setContentPane(new Bounce());
		frame.setSize(500, 500);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	}

	public void actionPerformed(ActionEvent e) {
		repaint();
	}
}
