public abstract class Shape implements Sprite {
	protected static final int HEIGHT = 35;

	protected static final int WIDTH = 25;

	protected int x;

	protected int y;

	protected int deltaX;

	protected int deltaY;

	public Shape(int x, int y, int deltaX, int deltaY) {
		this.x = x;
		this.y = y;
		this.deltaX = deltaX;
		this.deltaY = deltaY;
	}

	public void move(int width, int height) {
		int nextX = this.x + this.deltaX;
		int nextY = this.y + this.deltaY;

		if (nextX <= 0) {
			nextX = 0;
			this.deltaX = -this.deltaX;
		} else if (nextX + WIDTH >= width) {
			nextX = width - WIDTH;
			this.deltaX = -this.deltaX;
		}

		if (nextY <= 0) {
			nextY = 0;
			this.deltaY = -this.deltaY;
		} else if (nextY + HEIGHT >= height) {
			nextY = height - HEIGHT;
			this.deltaY = -this.deltaY;
		}

		this.x = nextX;
		this.y = nextY;
	}
}
