import junit.framework.TestCase;

public class TestBouncing extends TestCase {
	private MockPainter painter;

	private Animator animator;

	public void setUp() {
		painter = new MockPainter();
		animator = new Animator();
	}

	public void testShapeMoveWithBounceOffRight() {
		RectangleShape shape = new RectangleShape(100, 20, 12, 15);
		shape.paint(painter);
		shape.move(135, 10000);
		shape.paint(painter);
		shape.move(135, 10000);
		shape.paint(painter);
		assertEquals("(rectangle 100,20,25,35)(rectangle 110,35,25,35)"
				+ "(rectangle 98,50,25,35)", painter.toString());
	}

	public void testShapeMoveWithBounceOffLeft() {
		RectangleShape shape = new RectangleShape(10, 20, -12, 15);
		shape.paint(painter);
		shape.move(10000, 10000);
		shape.paint(painter);
		shape.move(10000, 10000);
		shape.paint(painter);
		assertEquals("(rectangle 10,20,25,35)(rectangle 0,35,25,35)"
				+ "(rectangle 12,50,25,35)", painter.toString());
	}

	public void testShapeMoveWithBounceOffBottomAndRight() {
		RectangleShape shape = new RectangleShape(10, 90, -12, 15);
		shape.paint(painter);
		shape.move(125, 135);
		shape.paint(painter);
		shape.move(125, 135);
		shape.paint(painter);
		assertEquals("(rectangle 10,90,25,35)(rectangle 0,100,25,35)"
				+ "(rectangle 12,85,25,35)", painter.toString());
	}
}
